// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/VelocityAccelCov.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/velocity_accel_cov__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__VelocityAccelCov__init(automotive_platform_msgs__msg__VelocityAccelCov * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__VelocityAccelCov__fini(msg);
    return false;
  }
  // velocity
  // accleration
  // covariance
  return true;
}

void
automotive_platform_msgs__msg__VelocityAccelCov__fini(automotive_platform_msgs__msg__VelocityAccelCov * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // velocity
  // accleration
  // covariance
}

bool
automotive_platform_msgs__msg__VelocityAccelCov__are_equal(const automotive_platform_msgs__msg__VelocityAccelCov * lhs, const automotive_platform_msgs__msg__VelocityAccelCov * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // velocity
  if (lhs->velocity != rhs->velocity) {
    return false;
  }
  // accleration
  if (lhs->accleration != rhs->accleration) {
    return false;
  }
  // covariance
  if (lhs->covariance != rhs->covariance) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__VelocityAccelCov__copy(
  const automotive_platform_msgs__msg__VelocityAccelCov * input,
  automotive_platform_msgs__msg__VelocityAccelCov * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // velocity
  output->velocity = input->velocity;
  // accleration
  output->accleration = input->accleration;
  // covariance
  output->covariance = input->covariance;
  return true;
}

automotive_platform_msgs__msg__VelocityAccelCov *
automotive_platform_msgs__msg__VelocityAccelCov__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__VelocityAccelCov * msg = (automotive_platform_msgs__msg__VelocityAccelCov *)allocator.allocate(sizeof(automotive_platform_msgs__msg__VelocityAccelCov), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__VelocityAccelCov));
  bool success = automotive_platform_msgs__msg__VelocityAccelCov__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__VelocityAccelCov__destroy(automotive_platform_msgs__msg__VelocityAccelCov * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_platform_msgs__msg__VelocityAccelCov__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__init(automotive_platform_msgs__msg__VelocityAccelCov__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__VelocityAccelCov * data = NULL;

  if (size) {
    data = (automotive_platform_msgs__msg__VelocityAccelCov *)allocator.zero_allocate(size, sizeof(automotive_platform_msgs__msg__VelocityAccelCov), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__VelocityAccelCov__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__VelocityAccelCov__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__fini(automotive_platform_msgs__msg__VelocityAccelCov__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__VelocityAccelCov__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__VelocityAccelCov__Sequence *
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__VelocityAccelCov__Sequence * array = (automotive_platform_msgs__msg__VelocityAccelCov__Sequence *)allocator.allocate(sizeof(automotive_platform_msgs__msg__VelocityAccelCov__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__VelocityAccelCov__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__destroy(automotive_platform_msgs__msg__VelocityAccelCov__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_platform_msgs__msg__VelocityAccelCov__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__are_equal(const automotive_platform_msgs__msg__VelocityAccelCov__Sequence * lhs, const automotive_platform_msgs__msg__VelocityAccelCov__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__VelocityAccelCov__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__VelocityAccelCov__Sequence__copy(
  const automotive_platform_msgs__msg__VelocityAccelCov__Sequence * input,
  automotive_platform_msgs__msg__VelocityAccelCov__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__VelocityAccelCov);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_platform_msgs__msg__VelocityAccelCov * data =
      (automotive_platform_msgs__msg__VelocityAccelCov *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__VelocityAccelCov__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__VelocityAccelCov__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__VelocityAccelCov__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
